;copyright 1989  lightwave research inc.
;moving light communications processor.
;version 1.7
;authors - steve tulk and lary cotten
;
;modified by ejwb 2005/6
;
;26/12/2005 	disasembly started
;02/01/2006 	initial commenting finished, program traced
;		reassembly without errors using asem-51
;
#include <p16f877a.inc>
#include "vars.h"
	
	
	org 0x00
	goto	l_start
	
	org 0x04
interrupt:
	;do interrupt handling	
	
;	interrupt for p3.2 (brk_int) - external interrupt 0
;	org	00003h
;	ajmp	l_int_brk_int				;0003	41 0e

;	interrupt for timer 0
;	org	0000bh
;	ajmp	l_int_tmr0				;000b	41 02

;	interrupt for p3.3 (lamp_int) - external interrupt 1
;	org	00013h
;	ajmp	l_int_lamp_int				;0013	61 9f

;	interrupt for timer 1
;	org	0001bh
;	ajmp	l_int_tmr1				;001b	41 05

;	interrupt for serial rx
;	org	00023h
;	ajmp	l_int_serial_rx				;0023	41 b2
;org 0x100

l_dimmer_dac_lookup:
	addwf	pcl,f		;movc	a,@a+pc
;
;
;lookup table for dimmer
;100 entries (percentage)
;	db 080h, 080h, 080h, 080h, 080h, 080h, 080h, 080h, 080h, 080h
;	db 080h, 080h, 080h, 080h, 080h, 080h, 080h, 080h, 080h, 080h
;	db 080h, 080h, 080h, 080h, 080h, 080h, 080h, 080h, 080h, 080h
;	db 080h, 080h, 080h, 080h, 080h, 080h, 080h, 080h, 080h, 080h
;	db 080h, 082h, 084h, 086h, 088h, 089h, 08bh, 08dh, 08fh, 091h
;	db 093h, 095h, 097h, 099h, 09bh, 09ch, 09eh, 0a0h, 0a2h, 0a4h
;	db 0a6h, 0a8h, 0aah, 0ach, 0aeh, 0afh, 0b1h, 0b3h, 0b5h, 0b7h
;	db 0b9h, 0bbh, 0bdh, 0bfh, 0c1h, 0c2h, 0c4h, 0c6h, 0c8h, 0cah
;	db 0cch, 0ceh, 0d0h, 0d2h, 0d4h, 0d5h, 0d7h, 0d9h, 0dbh, 0ddh
;	db 0dfh, 0e1h, 0e3h, 0e5h, 0e7h, 0e8h, 0eah, 0ech, 0eeh, 0f0h
table_dimmer:
;revised table for s-curve dimming of quartz lamp
	retlw 	08h
	retlw 	013h 
	retlw	019h 
	retlw	020h 
	retlw	024h 
	retlw	02ah 
	retlw	02dh 
	retlw	032h 
	retlw	034h 
	retlw	038h
	retlw 	03bh 
	retlw	03eh 
	retlw	041h 
	retlw	043h 
	retlw	045h 
	retlw	047h 
	retlw	04ah 
	retlw	04bh 
	retlw	04eh 
	retlw	050h
	retlw 	051h 
	retlw	053h 
	retlw	055h 
	retlw	057h 
	retlw	058h 
	retlw	05ah 
	retlw	05bh 
	retlw	05dh 
	retlw	05eh 
	retlw	060h
	retlw 	062h 
	retlw	063h 
	retlw	064h 
	retlw	066h 
	retlw	067h 
	retlw	068h 
	retlw	06ah 
	retlw	06bh 
	retlw	06ch 
	retlw	06eh
	retlw 	06fh 
	retlw	070h 
	retlw	071h 
	retlw	073h 
	retlw	074h 
	retlw	075h 
	retlw	076h 
	retlw	078h 
	retlw	079h 
	retlw	07ah
	retlw 	07ch 
	retlw	07dh 
	retlw	07eh 
	retlw	07fh 
	retlw	081h 
	retlw	082h 
	retlw	083h 
	retlw	084h 
	retlw	086h 
	retlw	087h
	retlw 	088h 
	retlw	08ah 
	retlw	08bh 
	retlw	08dh 
	retlw	08eh 
	retlw	08fh 
	retlw	090h 
	retlw	092h 
	retlw	093h 
	retlw	095h
	retlw 	097h 
	retlw	098h 
	retlw	09ah 
	retlw	09bh 
	retlw	09dh 
	retlw	09eh 
	retlw	0a0h 
	retlw	0a1h 
	retlw	0a3h 
	retlw	0a6h
	retlw 	0a7h 
	retlw	0a9h 
	retlw	0abh 
	retlw	0aeh 
	retlw	0afh 
	retlw	0b2h 
	retlw	0b4h 
	retlw	0b7h 
	retlw	0b9h 
	retlw	0bdh
	retlw 	0c1h 
	retlw	0c3h 
	retlw	0c8h 
	retlw	0cbh 
	retlw	0d1h 
	retlw	0d5h 
	retlw	0ddh 
	retlw	0e3h 
	retlw	0eeh 
	retlw	0ffh
	IF ((HIGH ($)) != (HIGH (table_dimmer)))
    	ERROR "TABLE1 CROSSES PAGE BOUNDARY!"
    ENDIF

;-------------------------------------------------------------

table_l07c7:
	addwf	pcl,f
	retlw	81h
	retlw	071h
	retlw	061h
	retlw	051h
	retlw	041h
	retlw	031h
	retlw	021h
	retlw	011h
	retlw	010h
	retlw	020h
	retlw	030h
	retlw	040h
	retlw	050h
	retlw	060h
	retlw	070h
	retlw	080h
	retlw	0bh
	retlw	00ah
	retlw	009h
	retlw	008h
	retlw	007h
	retlw	006h
	retlw	005h
	retlw	004h
	retlw	003h
	retlw	002h
	retlw	001h
	retlw	000h
	retlw	000h
	retlw	000h
	retlw	000h
	retlw	000h
table_l07e7:
	addwf	pcl,f
	retlw	80h
	retlw	070h
	retlw	060h
	retlw	050h
	retlw	040h
	retlw	030h
	retlw	020h
	retlw	010h
	retlw	011h
	retlw	021h
	retlw	031h
	retlw	041h
	retlw	051h
	retlw	061h
	retlw	071h
	retlw	081h
	retlw	0bh
	retlw	00ah
	retlw	009h
	retlw	008h
	retlw	007h
	retlw	006h
	retlw	005h
	retlw	004h
	retlw	003h
	retlw	002h
	retlw	001h
	retlw	000h
	retlw	000h
	retlw	000h
	retlw	000h
	retlw	000h

;-------------------------------------------------------------
	org		0x800
table_convert:
	addwf	pcl,f
	retlw	063h
	retlw	063h
	retlw	063h
	retlw	063h
	retlw	063h
	retlw	063h
	retlw	063h
	retlw	062h
	retlw	061h
	retlw	061h
	retlw	061h
	retlw	061h
	retlw	061h
	retlw	060h
	retlw	060h
	retlw	060h
	retlw	060h
	retlw	060h
	retlw	060h
	retlw	060h
	retlw	05fh
	retlw	05fh
	retlw	05fh
	retlw	05fh
	retlw	05fh
	retlw	05fh
	retlw	05fh
	retlw	05fh
	retlw	05fh
	retlw	05fh
	retlw	05eh
	retlw	05eh
	retlw	05eh
	retlw	05eh
	retlw	05eh
	retlw	05eh
	retlw	05eh
	retlw	05eh
	retlw	05eh
	retlw	05eh
	retlw	05eh
	retlw	05eh
	retlw	05eh
	retlw	05eh
	retlw	05dh
	retlw	05dh
	retlw	05dh
	retlw	05dh
	retlw	05dh
	retlw	05dh
	retlw	05dh
	retlw	05dh
	retlw	05dh
	retlw	05dh
	retlw	05dh
	retlw	05dh
	retlw	05dh
	retlw	05dh
	retlw	05dh
	retlw	05ch
	retlw	05ch
	retlw	05ch
	retlw	05ch
	retlw	05ch
	retlw	05ch
	retlw	05ch
	retlw	05ch
	retlw	05ch
	retlw	05ch
	retlw	05ch
	retlw	05ch
	retlw	05ch
	retlw	05ch
	retlw	05ch
	retlw	05ch
	retlw	05ch
	retlw	05ch
	retlw	05ch
	retlw	05ch
	retlw	05bh
	retlw	05bh
	retlw	05bh
	retlw	05bh
	retlw	05bh
	retlw	05bh
	retlw	05bh
	retlw	05bh
	retlw	05bh
	retlw	05bh
	retlw	05bh
	retlw	05bh
	retlw	05bh
	retlw	05bh
	retlw	05bh
	retlw	05bh
	retlw	05bh
	retlw	05bh
	retlw	05bh
	retlw	05bh
	retlw	05bh
	retlw	05bh
	retlw	05ah
	retlw	05ah
	retlw	05ah
	retlw	05ah
	retlw	05ah
	retlw	05ah
	retlw	05ah
	retlw	05ah
	retlw	05ah
	retlw	05ah
	retlw	05ah
	retlw	05ah
	retlw	05ah
	retlw	05ah
	retlw	05ah
	retlw	05ah
	retlw	05ah
	retlw	05ah
	retlw	05ah
	retlw	05ah
	retlw	05ah
	retlw	05ah
	retlw	05ah
	retlw	05ah
	retlw	05ah
	retlw	059h
	retlw	059h
	retlw	059h
	retlw	059h
	retlw	059h
	retlw	059h
	retlw	059h
	retlw	059h
	retlw	059h
	retlw	059h
	retlw	059h
	retlw	059h
	retlw	059h
	retlw	059h
	retlw	059h
	retlw	059h
	retlw	059h
	retlw	059h
	retlw	059h
	retlw	059h
	retlw	059h
	retlw	059h
	retlw	059h
	retlw	059h
	retlw	059h
	retlw	059h
	retlw	059h
	retlw	059h
	retlw	058h
	retlw	058h
	retlw	058h
	retlw	058h
	retlw	058h
	retlw	058h
	retlw	058h
	retlw	058h
	retlw	058h
	retlw	058h
	retlw	058h
	retlw	058h
	retlw	058h
	retlw	058h
	retlw	058h
	retlw	058h
	retlw	058h
	retlw	058h
	retlw	058h
	retlw	058h
	retlw	058h
	retlw	058h
	retlw	058h
	retlw	058h
	retlw	058h
	retlw	058h
	retlw	058h
	retlw	058h
	retlw	058h
	retlw	058h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	057h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw 	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	056h
	retlw	055h
;-------------------------------------------------------------
	org 0x400
;
l_start:
	bsf		bit_20,3			;setb		003h					;set bit 0x03 (0x20.3)
	movlw	0x00				;mov		02ch,#000h				;v2c=0
;	movwf	var_0x02			;
	clrwdt						;mov		dptr,#0028h
								;movx	@dptr,a
								;movx	@dptr,a
;	mov		sp,#060h			;sp=0x60
;	mov		scon,#092h			;scon=0x92 - 300baud to motor control board
;	orl		pcon,#080h			;pcon |= 0x80 - double baud rate (fclk/32)
	bsf		bit_21,4			;setb	00ch					;set bit 0x0c (0x21.4)
	bsf		bit_21,3			;setb	00bh					;set bit 0x0b (0x21.3)
	bcf		bit_21,5			;clr	00dh					;clear bit 0x21.5
	bcf		bit_21,2			;clr	00ah					;clear bit 0x21.2
	bcf		bit_21,0			;clr	008h					;clear bit 0x21.0
	bcf		bit_21,1			;clr	009h					;clear bit 0x21.1
;	setb	p3.2				;brk_int=1
;	setb	it0					;ito=1 (falling edge external trigger)
	movlw	0x0b				;mov	03ch,#00bh				;var_0x3c=0x0b
	movwf	var_0x3c			;
	movlw	0x34				;mov	01fh,#034h				;var_0x1f=0x34
	movwf	var_0x1f			;
	clrf	var_0x5a			;mov	05ah,#000h				;var_0x5a=0;
	movlw	0x05				;mov	03dh,#005h				;var_0x3d=0x05
	movwf	var_0x3d			;
	movlw	0xce				;mov	03eh,#0ceh				;var_0x3e=0xce
	movwf	var_0x3e			;
	movlw	0x0c				;mov	02bh,#00ch				;var_0x2b=0x0c
	movwf	var_0x2b			;
	movlw	0xff				;mov	02ah,#0ffh				;var_0x2a=0xff
	movwf	var_0x2a			;
	clrf	var_0x59			;mov	059h,#000h				;var_0x59=0x00
;	mov	tmod,#011h				;tmod=0x11
;	setb	et0					;set bit et0 (enable timer 0 overflow interrupt)
;	clr	et1						;clear bit et1 (disable timer 1 overflow interrupt)
;	setb	tr0					;set bit tr0 (set timer 0 overflow flag)
;	setb	tr1					;set bit tr1 (set timer 1 overflow flag)
	movlw	0x80				;mov	02eh,#080h				;var_0x2e=0x80
	movwf	var_0x2e			;
	movlw	0xff				;mov	02fh,#0ffh				;var_0x2f=0xff
	movwf	var_0x2f			;
	bcf		bit_22,0			;clr	010h					;clear bit 0x22.0
	bcf		bit_22,1			;clr	011h					;clear bit 0x22.1
	bcf		bit_23,0			;clr	018h					;clear bit 0x23.0
	bcf		bit_22,2			;clr	012h					;clear bit 0x22.2
	bcf		bit_22,3			;clr	013h					;clear bit 0x22.3
	bcf		bit_22,4			;clr	014h					;clear bit 0x22.4
	bcf		bit_23,4			;clr	01ch					;clear bit 0x23.4
	clrf	var_0x58			;mov	058h,#000h
	clrf	var_0x30			;mov	030h,#000h
	clrf	var_0x31			;mov	031h,#000h
;
l0163:	
	clrf	var_0x32			;mov	032h,#000h
	clrf	var_0x33			;mov	033h,#000h
	movlw	0x05				;mov	034h,#05ah
	movwf	var_0x34
	clrf	var_0x35			;mov	035h,#000h
	clrf	var_0x36			;mov	036h,#000h
	movlw	0x63				;mov	037h,#063h
	movwf	var_0x37			;
	clrf	var_0x38			;mov	038h,#000h
	clrf	var_0x30			;mov	039h,#000h
	movlw	0x63				;mov	03ah,#063h
	movwf	var_0x3a
	clrf	var_0x3f			;mov	03fh,#000h
	clrf	var_0x40			;mov	040h,#000h
	clrf	var_0x41			;mov	041h,#000h
	clrf	var_0x42			;mov	042h,#000h
	movlw	0x05				;mov	043h,#05ah
	movwf	var_0x43
	clrf	var_0x44			;mov	044h,#000h
	clrf	var_0x45			;mov	045h,#000h
	movlw	0x63				;mov	046h,#063h
	movwf	var_0x46
	clrf	var_0x47			;mov	047h,#000h
	clrf	var_0x48			;mov	048h,#000h
	movlw	0x63				;mov	049h,#063h
	movwf	var_0x49
	clrf	var_0x4a			;mov	04ah,#000h
	clrf	var_0x4b			;mov	04bh,#000h
	clrf	var_0x4c			;mov	04ch,#000h
	clrf	var_0x4d			;mov	04dh,#000h
	clrf	var_0x4e			;mov	04eh,#000h
	clrf	var_0x4f			;mov	04fh,#000h
	clrf	var_0x50			;mov	050h,#000h
	clrf	var_0x51			;mov	051h,#000h
	clrf	var_0x52			;mov	052h,#000h
	clrf	var_0x53			;mov	053h,#000h
	clrf	var_0x54			;mov	054h,#000h
	clrf	var_0x55			;mov	055h,#000h
	clrf	var_0x56			;mov	056h,#000h
	clrf	var_0x57			;mov	057h,#000h
	clrf	var_0x5b			;mov	05bh,#001h
	clrf	var_0x5e			;mov	05eh,#000h
	clrf	var_0x5f			;mov	05fh,#000h
	bcf		bit_20,1			;clr	001h					;clear bit 0x20.1
	bcf		bit_20,0			;clr	000h					;clear bit 0x20.0
	movlw	0x59				;mov	02dh,#059h
	movwf	var_0x2d
;	clr	it1						;set low level trigger external interrupt
	movlw	0x63				;mov	a,#063h					;acc = 0x63
	movwf	var_0x3a			;mov	03ah,a					;v0x3a = acc
	lcall	l_dimmer_dac_lookup	;call l_dimmer_dac_lookup
;	mov	dptr,#0010h				;data pointer = #l0010
;	movx	@dptr,a				;external address 0x0010 = acc (set dimmer dac)
	bcf		bit_20,1			;clr	001h					;clear bit 0x20.1
	clrf	var_0x1d			;mov	01dh,#000h
	clrf	var_0x1e			;mov	01eh,#000h
	movlw	0x63				;mov	018h,#063h
	movwf	var_0x18
	movlw	0x63				;mov	019h,#063h
	movwf	var_0x19
	bcf		bit_24,1			;clr	021h					;clear bit 0x24.1
	bcf		bit_24,2			;clr	022h					;clear bit 0x24.2
;	clr	p1.0					;clear p1.0 (fan led on)
	lcall	l1dcb				;lcall	l1dcb					;call l1dcb
	bsf		intcon,gie			;setb	ea					;enable global interrupts
	pagesel	l_main_loop
	goto	l_main_loop			;ljmp	l_main_loop				;goto l_main_loop
;
;---------------------------------------------------------------
;*** tmr0 interrupt ***
;
l_int_tmr0:	
	bsf		bit_20,4			;setb	004h				;0x20.4=1
	retfie						;reti
;
;---------------------------------------------------------------
;*** tmr1 interrupt ***
l_int_tmr1:
	banksel tmr1l
	movlw	0xf5				;mov	tl1,#0f5h				;tmr1=0xe5f5
	movwf	tmr1l				;
	movlw	0xe5				;mov	th1,#0e5h
	movwf	tmr1h				;
	incf	var_0x1a,f			;inc	01ah					;var_0x1a++
	banksel	porta
	retfie						;reti						;return
;
;---------------------------------------------------------------
;*** brk interrupt ***
;r0 buffer start address (0x10)
;r1 timeout
;r2 timeout
;r3 number of bytes (0x08)
;r4 0=dmx1-2561=dmx257-512
;r5 dmx channel

l_int_brk_int:
;	push	dph
;	push	dpl
;	push	psw
;	push	acc
;	mov	psw,#008h				;psw=0x08 (carry flag = 1)
	movlw	0x0a				;mov	r6,#00ah				;r6 = 0x0a
	movwf	r6					;
;
l021b:	
	;Check BRK pin stays low for 10 cycles (glitch prevention)
	btfsc	p3,2				;jb		p3.2,l0228				;if p3.2=1 then goto l0228
	goto	l0228
	btfsc	bit_21,0			;jb		008h,l0228				;if 0x21.0=1 then goto l0228
	goto	l0228
	decfsz	r6,f				;djnz	r6,l022a				;if(r6--)>0 goto l022a
	goto	l021b				;
	goto	l_retfie_brk		;ljmp	l_retfie_brk				;goto l_retife_brk
;
								;ajmp	l022a					;goto l022a
;
;
l0228:	
	goto	l_retfie_brk		;ajmp	l_retfie_brk				;goto l_retife_brk
;
;
l022a:	
	movlw	0xd3				;mov	r1,#0d3h				;r1=0xd3
	movwf	r1					;
	movlw	0x01				;mov	r2,#001h				;r2=0x01
	movwf	r2					;
;
l022e:	
								;mov	dptr,#0028h				;dptr = 0x0028
;
;	wait for brk_int to go high
;	goto l023d if high,goto l_retfie_brk if timeout
l0231:	
	clrwdt						;movx	@dptr,a					;external 0x0028 = acc
								;movx	@dptr,a
	btfsc	p3,2				;jb	p3.2,l023d				;jump to l023d if brk_int is high
	goto	l023d
	decfsz	r2,f				;djnz	r2,l022e				;decrement r2, jump to l022e if not zero
	goto	l022e				;
	decfsz	r1,f				;djnz	r1,l022e				;decrement r1, jump to l022e if not zero
	goto	l022e
	goto	l_retfie_brk		;ljmp	l_retfie_brk				;timeout on brk signal, goto l_retfie_brk
;
;
l023d:	
	bcf		pir1,rcif			;clr	ri
	movlw	0xff				;mov	r1,#0ffh				;r1=0xff
	movwf	r1					;
	movlw	0xff				;
	movwf	r2					;mov	r2,#0ffh				;r2=0xff
;
;	wait for rcif to go high
;	timeout via r1 and r2.
;	goto l021b if low, goto l_retfie_brk if timeout, goto l0255 if ri goes high
l0243:	
	clrwdt						;mov	dptr,#0028h				;
								;movx	@dptr,a					;
								;movx	@dptr,a					;external 0x0028 = acc
	btfsc	pir1,rcif			;jb		ri,l0255				;jump to l0255 if ri is high
	goto	l0255
	btfss	p3,2				;jnb	p3.2,l021b				;jump to l021b if brk_int is low
	goto	l021b				;
	decfsz	r2,f				;djnz	r2,l0243				;decrement r2, jump to l0243 if not zero
	goto	l0243
	decfsz	r1,f				;djnz	r1,l0243				;decrement r1, jump to l0243 if not zero
	goto	l0243
	goto	l_retfie_brk		;ljmp	l_retfie_brk			;timeout, goto l_retfie_brk
;
;
l0255:	
	;Check first byte = 0x00 (start)
	bcf		pir1,rcif			;clr	ri						;clear rx interrupt flag
	movf	rcreg,w				;mov	a,sbuf					;accumulator = sbuf
	btfsc	status,z			;cjne	a,#000h,l_retfie_brk	;if acc != 0 then goto l_retfie_brk (retfie)
	goto	l_retfie_brk
	clrf	r4					;mov	r4,#000h				;r4=0
	btfss	bit_22,2			;jb		012h,l0263				;if bit 22.2=0 then goto l0263 (dmx1-256)
	goto	l0263				;
	movlw	0x01				;mov		r4,#001h				;r4=1
	movwf	r4
;
l0263:	
	movf	var_0x3b,w			;mov	r5,03bh					;r5=var_0x3b (dmx channel)
	movwf	r5
	movlw	0x08				;mov	r3,#008h				;r3=0x08 (number of bytes)
	movwf	r3
	movlw	0x20				;mov	r0,#010h				;r0=0x10 (buffer start address)
	movwf	fsr
;
l0269:	
	movlw	0xd3				;mov	r1,#0d3h				;r1=0xd3
	movwf	r1
	movlw	0x01				;mov	r2,#001h				;r2=0x01
	movwf	r2
;
l026d:	
	clrwdt						;mov	dptr,#0028h
								;movx	@dptr,a
								;movx	@dptr,a
	btfsc	pir1,rcif			;jb	ri,l027f					;if ri then goto l027f
	goto	l027f
	btfss	p3,2				;jnb	p3.2,l021b				;if brk_int=0 then goto l021b
	goto	l021b
	decfsz	r2,f				;djnz	r2,l026d				;if(r2--)>0 then goto l026d
	goto	l026d
	decfsz	r1,f				;djnz	r1,l026d				;if(r1--)>0 then goto l026d
	goto	l026d
	goto	l_retfie_brk		;ljmp	l_retfie_brk			;goto l_retfie_brk (retfie)
;
;
l027f:	
	bsf		pir1,rcif			;clr	ri						;ri=0
	movf	r3,w				;cjne	r3,#000h,l0287			;if r3!=0 then goto l0287 (more bytes to come)
	btfsc	status,z
	goto	l_retfie_brk		;ljmp	l_retfie_brk			;goto l_retfie_brk (retfie)
;
;
l0287:	
	movf	r5,w				;cjne	r5,#000h,l029a			;if r5!=0 then goto l029a - r5=0 when selected channels are incoming
	btfss	status,z
	goto	l029a
	movf	r4,w				;cjne	r4,#000h,l029a			;if r4!=0 then goto l029a - dmx257-512 selected
	btfss	status,z
	goto	l029a
	movf	rcreg,w				;mov	a,sbuf					;acc = sbuf
	movwf	indf				;mov	@r0,a					;ram[r0]=acc
	incf	fsr,f				;inc	r0						;incf fsr
	bsf		bit_21,0			;setb	008h					;set bit 21.0
	bsf		bit_21,1			;setb	009h					;set bit 21.1
	decfsz	r3,f				;djnz	r3,l0269				;if (r3--)>0 then goto l0269 - more bytes?
	goto	l0269
	goto	l_retfie_brk		;ljmp	l_retfie_brk				;goto l_retfie_brk (retfie)
;
;
l029a:	
	movf	rcreg,w				;mov	a,sbuf					;acc = sbuf
	bcf		status,c			;clr	c						;carry = 0
	decf	r5,f				;mov	a,r5					;acc = r5
								;subb	a,#001h					;acc = acc - 1
								;mov	r5,a					;r5 = acc (count down dmx channels to skip)
	movf	r4,w				;mov	a,r4					;acc = r4
	sublw	0					;subb	a,#000h					;acc = acc - 0
	movwf	r4					;mov	r4,a					;r4 = acc (eh?)
	goto	l0269				;ajmp	l0269					;goto l0269
;
;
l_retfie_brk:
	clrf	r3					;mov	r3,#000h				;retfie
;	pop	acc
;	pop	psw
;	pop	dpl
;	pop	dph
	retfie						;	reti
;
;---------------------------------------------------------------
;*** serial rx interrupt ***

l_int_serial_rx:
	retfie
;---------------------------------------------------------------
;*** lamp interrupt ***
l_int_lamp_int:
;	clr	ea
;	push	acc
;	push	dpl
;	push	dph
;	push	psw
;	mov	a,r7			;acc = r7
;	push	acc			;backup for later
;	mov	a,r6			;acc = r6
;	push	acc			;backup for later
;	jb	p1.3,l03c4		;if p1.3 (rst_ena)=1 then goto l03c4
;	mov	r7,#03dh		;r7=0x3d
;	mov	r6,#000h		;r6=0x00
;	setb	p3.3			;p3.3 (lamp_int)=1
;
;l03b8:	
;	jb	p3.3,l03c4		;if lamp_int=1 then goto l03c4
;	djnz	r6,l03b8		;if(r6--)>0 then goto l03b8
;	djnz	r7,l03b8		;if(r7--)>0 then goto l03b8
;	lcall	l_set_lamp_off			;timeout.  goto l_set_lamp_off
;	setb	001h
;
;l03c4:	
;	pop	acc			;get values back from stack backup
;	mov	r6,a
;	pop	acc
;	mov	r7,a
;	pop	psw
;	pop	dph
;	pop	dpl
;	pop	acc
;
;l03d2:	
;	setb	ea
;	reti				;return
;---------------------------------------------------------------
;BIT_21,5 is cleared at the start and does not get set...!
l03d5:	
	btfss	bit_21,5		;jnb	00dh,l03e5		;if 0x21.5=0 then goto l03e5 (immediate exit)
	goto	l03e5		
	movlw	0x1f			;mov	a,#01fh			;acc = 0x1f
	lcall	l_send_tx		;call l_send_tx
	movlw	0x10			;mov	a,#010h			;acc = 0x10
	movwf	r0
;
l03df:	
	nop
	decfsz	r0,f			;dec	a				;acc--
							;jnz	l03df			;if >0, goto l03df
	goto	l03df
	bcf		bit_21,5		;clr	00dh			;0x21.5=0
;
l03e5:	
	return					;ret					;return
;---------------------------------------------------------------
;*** transmit to motor board ***
l_send_tx:
	movwf	r1				;push	acc				;put acc onto the stack for later
	movlw	0x55			;mov	a,#055h			;acc=0x55
	movwf	r0
;
l03ea:	
	clrwdt					;mov	dptr,#0028h		;
							;movx	@dptr,a			;
							;movx	@dptr,a			;0x0028 = acc
	decfsz	r0,f			;djnz	acc,l03ea		;if(acc--)>0 goto l03ea
	goto	l03ea
	movf	r1,w			;pop	acc				;get acc back from the stack
;
l03f4:	
	clrwdt					;mov	dptr,#0028h
							;movx	@dptr,a
							;movx	@dptr,a			;0x0028 = acc
	btfsc	bit_21,4		;jb		00ch,l0401		;if 0x21.4=1 then goto l0401
	goto	l0401
;	btfss	pir1,txif		;jb	ti,l0401			;if transmit flag=1 then goto l0401
;	goto	l03f4			;ajmp	l03f4			;loop round to l03f4
;
;
l0401:	
	bcf		pir1,txif		;clr	ti				;transmit flag=0
	banksel	txsta
	bsf		txsta,tx9		;setb	tb8			;9th bit to transmit=1
	bcf		bit_21,4		;clr	00ch			;0x21.4=0
	banksel	txreg
	movwf	txreg			;mov	sbuf,a			;send acc to motor board
	bsf		intcon,gie		;setb	ea			;enable global interrupts
;
l040b:	
	nop						;wait a bit...
	nop
	nop
	return					;ret				;return
;---------------------------------------------------------------
;
l040f:	
	btfss	bit_22,5		;jnb	015h,l042a		;if 0x22.5 = 0 then goto l042a (immediate exit)
	goto	l042a
	bcf		status,c		;clr	c			;clear carry

	;var_0x31=0xce-var_0x31
	movf	var_0x31,w		;mov	a,#0ceh			;acc = 0xce
	sublw	0xce			;subb	a,031h			;acc=acc-var_0x31
	movwf	var_0x31		;mov	031h,a			;var_0x31=acc

	;var_0x30=0x0b-var_0x30
	movf	var_0x30,w		;mov	a,#00bh			;acc = 0x0b
	sublw	0x0b			;subb	a,030h			;acc=acc-var_0x30
	btfsc	status,c		;jc		l0424			;if carry=1 then goto l0424
	goto	l0424			;
	movwf	var_0x30		;mov	030h,a			;var_0x30=acc
	goto	l042a			;ljmp	l042a			;goto l042a (immediate exit)
;
;
l0424:	
	clrf	var_0x30		;mov	030h,#000h		;var_0x30=0
	clrf	var_0x31		;mov	031h,#000h		;var_0x31=0
;
l042a:	
	return					;ret
;---------------------------------------------------------------
;
l_convert_motor_values:
	;pan motor setting
	;takes the value in var_0x30, saves into var_0x3f
	;takes low nibble, prefixes 0x2n and stores in var_0x4a
	;takes igh nibble, prefixes 0x2n and stores in var_0x4b
	;eg, var_0x30 = 0x7f:
	;var_0x3f = 0x7f
	;var_0x4a = 0x2f
	;var_0x4b = 0x27
	movf	var_0x30,w		;mov	a,030h			;
	movwf	var_0x3f		;mov	03fh,a			;acc = var_0x3f = var_0x30
							;mov	b,a				;b = var_0x30
	andlw	0x0f			;anl	a,#00fh			;acc &=0x0f
	addlw	0x20			;add	a,#020h			;acc +=0x20
	movwf	var_0x4a		;mov	04ah,a			;var_0x4a=((var_0x30 & 0x0f) + 0x20)
	movf	0x30,w			;mov	a,b				;acc=b
	andlw	0xf0			;anl	a,#0f0h			;acc &=0xf0
	movwf	r0
	swapf	r0,w			;swap	a				;swap acc
	addlw	0x20			;add	a,#020h			;acc += 0x20
	movwf	var_0x4b		;mov	04bh,a			;var0x4b=acc

	
	;takes the value in var_0x31, saves into var_0x40
	;takes low nibble, prefixes 0x2n and stores in var_0x4c
	;takes igh nibble, prefixes 0x2n and stores in var_0x4d
	movf	var_0x31,w		;mov	a,031h			;acc = var_0x31
	movwf	var_0x40		;mov	040h,a			;var_0x40=acc
							;mov	b,a			;b=acc
	andlw	0x0f			;anl	a,#00fh			;acc &= 0x0f
	addlw	0x20			;add	a,#020h			;acc += 0x20
	movwf	var_0x4c		;mov	04ch,a			;var_0x4c=acc
	movf	var_0x31,w		;mov	a,b			;acc=b
	andlw	0xf0			;anl	a,#0f0h			;acc &= 0xf0
	movwf	r0				;
	swapf	r0,w			;swap	a			;swap acc
	addlw	0x20			;add	a,#020h			;acc += 0x20
	movwf	var_0x4d		;mov	04dh,a			;var_0x4d=acc

	;tilt
	;takes the value in var_0x32, saves into var_0x41
	;takes low nibble, prefixes 0x2n and stores in var_0x4e
	;takes igh nibble, prefixes 0x2n and stores in var_0x4f
	movf	var_0x32,w		;mov	a,032h
	movwf	var_0x41		;mov	041h,a
							;mov	b,a
	andlw	0x0f			;anl	a,#00fh
	addlw	0x20			;add	a,#020h
	movwf	var_0x4e		;mov	04eh,a
	movf	var_0x32,w		;mov	a,b
	andlw	0xf0			;anl	a,#0f0h
	movwf	r0				;
	swapf	r0,w			;swap	a
	addlw	0x20			;add	a,#020h
	movwf	var_0x4f		;mov	04fh,a

	
	;takes the value in var_0x33, saves into var_0x42
	;takes low nibble, prefixes 0x2n and stores in var_0x50
	;takes igh nibble, prefixes 0x2n and stores in var_0x51
	movf	var_0x33,w		;mov	a,033h
	movwf	var_0x42		;mov	042h,a
							;mov	b,a
	andlw	0x0f			;anl	a,#00fh
	addlw	0x20			;add	a,#020h
	movwf	var_0x50		;mov	050h,a
	movf	var_0x33,w		;mov	a,b
	andlw	0xf0			;anl	a,#0f0h
	movwf	r0				;
	swapf	r0,w			;swap	a
	addlw	0x20			;add	a,#020h
	movwf	var_0x51		;mov	051h,a


	movf	var_0x34,w		;mov	a,034h
	movwf	var_0x43		;mov	043h,a		;var_0x43 = var_0x34
	addlw	0x20			;add	a,#020h
	movwf	var_0x52		;mov	052h,a		;var_0x52 = var_0x34 + 0x20

	movf	var_0x35,w		;mov	a,035h
	movwf	var_0x44		;mov	044h,a		;var_0x44 = var_0x35
	addlw	0x20			;add	a,#020h
	movwf	var_0x53		;mov	053h,a		;var_0x53 = var_0x35 + 0x20

	movf	var_0x36,w		;mov	a,036h
	movwf	var_0x45		;mov	045h,a		;var_0x45 = var_0x36
	addlw	0x20			;add	a,#020h
	movwf	var_0x54		;mov	054h,a		;var_0x54 = var_0x36 + 0x20

	movf	var_0x37,w		;mov	a,037h
	movwf	var_0x46		;mov	046h,a		;var_0x46 = var_0x37
	addlw	0x20			;add	a,#020h
	movwf	var_0x55		;mov	055h,a		;var_0x55 = var_0x37 + 0x20

	movf	var_0x38,w		;mov	a,038h
	movwf	var_0x47		;mov	047h,a		;var_0x47 = var_0x38
	addlw	0x20			;add	a,#020h
	movwf	var_0x56		;mov	056h,a		;var_0x56 = var_0x38 + 0x20

	movf	var_0x39,w		;mov	a,039h
	movwf	var_0x48		;mov	048h,a		;var_0x48 = var_0x39
	addlw	0x20			;add	a,#020h
	movwf	var_0x57		;mov	057h,a		;var_0x57 = var_0x39 + 0x20
	return					;ret
;---------------------------------------------------------------
;***update motor board***
;if nothing has changed, var_0x58 counts up to 0x30 then updates motor board.
;if something has changed, update the motor board imeediately.
l_update_motor_board:
	movf	var_0x30,w		;mov	a,030h
	xorwf	var_0x3f,w		;xrl	a,03fh
	btfsc	status,z		;jnz	l_recalculate_motor_values		;if (var_0x30!=var_0x3f) goto l_recalculate_motor_values
	goto	l_recalculate_motor_values
	movf	var_0x31,w		;mov	a,031h
	xorwf	var_0x40,w		;xrl	a,040h
	btfsc	status,z		;jnz	l_recalculate_motor_values		;if (var_0x31!=var_0x40) goto l_recalculate_motor_values
	goto	l_recalculate_motor_values
	movf	var_0x32,w		;mov	a,032h
	xorwf	var_0x41,w		;xrl	a,041h
	btfsc	status,z		;jnz	l_recalculate_motor_values		;if (var_0x32!=var_0x41) goto l_recalculate_motor_values
	goto	l_recalculate_motor_values
	movf	var_0x33,w		;mov	a,033h
	xorwf	var_0x42,w		;xrl	a,042h
	btfsc	status,z		;jnz	l_recalculate_motor_values		;if (var_0x33!=var_0x42) goto l_recalculate_motor_values
	goto	l_recalculate_motor_values
	movf	var_0x34,w		;mov	a,034h
	xorwf	var_0x43,w		;xrl	a,043h
	btfsc	status,z		;jnz	l_recalculate_motor_values		;if (var_0x34!=var_0x43) goto l_recalculate_motor_values
	goto	l_recalculate_motor_values
	movf	var_0x35,w		;mov	a,035h
	xorwf	var_0x44,w		;xrl	a,044h
	btfsc	status,z		;jnz	l_recalculate_motor_values		;if (var_0x35!=var_0x44) goto l_recalculate_motor_values
	goto	l_recalculate_motor_values
	movf	var_0x36,w		;mov	a,036h
	xorwf	var_0x45,w		;xrl	a,045h
	btfsc	status,z		;jnz	l_recalculate_motor_values		;if (var_0x36!=var_0x45) goto l_recalculate_motor_values
	goto	l_recalculate_motor_values
	movf	var_0x37,w		;mov	a,037h
	xorwf	var_0x46,w		;xrl	a,046h
	btfsc	status,z		;jnz	l_recalculate_motor_values		;if (var_0x37!=var_0x46) goto l_recalculate_motor_values
	goto	l_recalculate_motor_values
	movf	var_0x38,w		;mov	a,038h
	xorwf	var_0x47,w		;xrl	a,047h
	btfsc	status,z		;jnz	l_recalculate_motor_values		;if (var_0x38!=var_0x47) goto l_recalculate_motor_values
	goto	l_recalculate_motor_values
	movf	var_0x39,w		;mov	a,039h
	xorwf	var_0x48,w		;xrl	a,048h
	btfsc	status,z		;jnz	l_recalculate_motor_values		;if (var_0x39!=var_0x48) goto l_recalculate_motor_values
	goto	l_recalculate_motor_values
							;mov	a,058h
	incf	var_0x58,w		;inc	a
	movwf	var_0x58		;mov	058h,a					;var_0x58++
	xorlw	0x30			;xrl	a,#030h
	btfss	status,z		;jz	l_recalculate_motor_values		;if(var_0x58 = 0x30) goto l_recalculate_motor_values
	goto	l0549			;ljmp	l0549					;else goto l0549 - immediate exit
;
;something has changed - update the values
l_recalculate_motor_values:
	movf	var_0x30,w		;push	030h			;backup var_0x30
	movwf	r2
	movf	var_0x31,w		;push	031h			;backup var_0x31
	movwf	r1
	lcall	l040f			;acall	l040f			;call l040f
	lcall	l_convert_motor_values	;acall	l_convert_motor_values	;call l_convert_motor_values
	movf	r1,w			;pop	031h			;restore var_0x31
	movwf	var_0x31
	movf	r2,w			;pop	030h			;restore var_0x30
	movwf	var_0x30
	clrf	var_0x58		;mov	058h,#000h		;var_0x58=0x00
	movlw	0x10			;mov	a,#010h			;
	call	l_send_tx		;acall	l_send_tx		;send 0x10 	start byte?
	movlw	0x10			;mov	a,#010h			;acc = 0x10
	movwf	r0
;
l050d:	
	nop
	decfsz	r0,f				;dec	a			;acc --
	goto	l050d			;jnz	l050d			;if acc!=0 goto l050d (wait briefly before sending data)

	movf	var_0x4a,w		;mov	a,04ah
	call	l_send_tx		;acall	l_send_tx		;send var_0x4a
	movf	var_0x4b,w		;mov	a,04bh
	call	l_send_tx		;acall	l_send_tx		;send var_0x4b
	movf	var_0x4c,w		;mov	a,04ch
	call	l_send_tx		;acall	l_send_tx		;send var_0x4c
	movf	var_0x4d,w		;mov	a,04dh
	call	l_send_tx		;acall	l_send_tx		;send var_0x4d
	movf	var_0x4e,w		;mov	a,04eh
	call	l_send_tx		;acall	l_send_tx		;send var_0x4e
	movf	var_0x4f,w		;mov	a,04fh
	call	l_send_tx		;acall	l_send_tx		;send var_0x4f
	movf	var_0x50,w		;mov	a,050h
	call	l_send_tx		;acall	l_send_tx		;send var_0x50
	movf	var_0x51,w		;mov	a,051h
	call	l_send_tx		;acall	l_send_tx		;send var_0x51
	movf	var_0x52,w		;mov	a,052h
	call	l_send_tx		;acall	l_send_tx		;send var_0x52
	movf	var_0x53,w		;mov	a,053h
	call	l_send_tx		;acall	l_send_tx		;send var_0x53
	movf	var_0x54,w		;mov	a,054h
	call	l_send_tx		;acall	l_send_tx		;send var_0x54
	movf	var_0x55,w		;mov	a,055h
	call	l_send_tx		;acall	l_send_tx		;send var_0x55
	movf	var_0x56,w		;mov	a,056h
	call	l_send_tx		;acall	l_send_tx		;send var_0x56
	movf	var_0x57,w		;mov	a,057h
	call	l_send_tx		;acall	l_send_tx		;send var_0x57
;
l0549:	
	bsf		intcon,gie		;setb	ea			;enable global interrupts
	return					;ret				;return
;---------------------------------------------------------------
;convert dmx pan value?
;0x10 = current pan value
;0x1d = last pan value

l_convert_dmx_pan:
	movf	var_0x10,w		;mov	a,010h			;acc = var_0x10
	movwf	var_0x1d		;moved from l055a
	bcf		status,c		;clr	c				;carry=0
	subwf	var_0x1d,w		;subb	a,01dh			;acc=acc-var_0x1d
	sublw	0			;w=w-0x1d
	btfsc	status,z		;jnz	l0556			;if var_0x10 != var_0x1d then goto l0556
	goto	l0599			;ljmp	l0599			;else goto l0599
;
;dmx pan value has changed
l0556:	
	btfss	status,c		;jnc	l055a			;if carry=0 then goto l055a
	goto	l055a			;jump if 
	movwf	r0
	comf	r0,f			;cpl	a			;acc=!acc
	incf	r0,w			;inc	a			;acc++
;update last pan value
l055a:	
;	mov		01dh,010h		;var_0x1d = var_0x10
	btfsc	status,c		;jc		l056f			;if carry=1 then goto l056f
	goto	l056f
	bcf		p1,5			;clr	p1.5			;p1.5=0 (not connected)
	nop
	bsf		p1,5			;setb	p1.5			;p1.5=1
	movlw	0x63			;mov	018h,#063h		;var_0x18=0x63
	movwf	var_0x18
	bcf		bit_24,0			;clr	021h			;24.1=0
	goto	l0599			;ljmp	l0599			;goto l0599 (exit)
;
;
l056f:	
	btfsc	bit_24,1		;jb	021h,l0582		;if 24.1=1 then goto l0582
	goto	l0582
	bcf		p1,6			;clr	p1.6			;p1.6=0 (not connected)
	nop
	bsf		p1,6			;setb	p1.6			;p1.6=1
	movlw	0x5c			;mov	018h,#05ch		;var_0x18=0x5c
	movwf	var_0x18
	clrf	var_0x1b		;mov	01bh,#000h		;var_0x1b=0x00
	bsf		bit_24,1		;setb	021h			;24.1=1
	goto	l0599			;ljmp	l0599			;goto l0599 (exit)
;
;
l0582:
	bcf		p1,4			;clr	p1.4			;p1.4=0 (not connected)
	nop
	bsf		p1,4			;setb	p1.4			;p1.4=1
	movlw	var_0x1b		;mov	a,01bh			;acc=var_0x1b
	addlw	0x0c			;add	a,#00ch			;acc += 0x0c
	;mov	dptr,#l05e8		;pointer=l05e8 (lookup table)
	;movc	a,@a+dptr		;acc = data from table[acc]
	lcall	table_convert
	movwf	var_0x18		;mov	018h,a			;var_0x18=acc
	clrf	var_0x1b		;mov	01bh,#000h		;var_0x1b=0x00
	bsf		bit_24,1		;setb	021h			;24.1=1
	;ljmp	l0599			;exit
;
;
l0599:	
	return					;ret				;return
;---------------------------------------------------------------
;
l_convert_dmx_tilt:
	movf	var_0x11,w		;mov	a,011h			;acc = var_0x11
	movwf	var_0x1e		;moved from l05a8
	bcf		status,c		;clr	c               	;carry=0
	subwf	var_0x1e,w		;subb	a,01eh          	;acc=acc-var_0x1e
	sublw	0
	btfsc	status,z		;jnz	l05a4           	;if var_0x11 == var_0x1e then goto l05a4
	goto	l05e7			;ljmp	l05e7           	;else goto l05e7 (exit)
;
;
l05a4:	
	btfss	status,c		;jnc	l05a8           	;if carry=0 then goto l05a8
	goto	l05a8			;
	movwf	r0	
	comf	r0,f			;cpl	a               	;acc=!acc
	incf	r0,w			;inc	a               	;acc++
;
l05a8:	
	;mov	01eh,011h       	;var_0x1e = var_0x11
	;cjne	a,#00bh,l05ae   	;if acc!=0x0bh goto l05ae
;
l05ae:	
	btfsc	status,c			;jc	l05bd           	;if carry=1 then goto l05bd
	goto	l05bd
	bcf		p1,5				;clr	p1.5            ;p1.5=0 (not connected)
	nop
	bsf		p1,5				;setb	p1.5            ;p1.5=1
	movlw	0x63				;mov	019h,#063h      ;var_0x19=0x63
	movwf	var_0x19			
	bcf		bit_24,1			;clr	022h            ;24.1=0
	lgoto	l05e7				;ljmp	l05e7           	;goto l05e7 (exit)
;
;
l05bd:	
	btfsc	bit_24,2			;jb	022h,l05d0      	;if 24.2=1 then goto l05d0
	goto	l05d0
	bcf		p1,6				;clr	p1.6            	;p1.6=0 (not connected)
	nop
	bsf		p1,6				;setb	p1.6            	;p1.6=1
	movlw	0x05				;mov	019h,#05ch      	;var_0x19=0x5c
	movwf	var_0x19
	clrf	var_0x1c			;mov	01ch,#000h      	;var_0x1c=0x00
	bsf		bit_24,1			;setb	022h            	;24.2=1
	lgoto	l05e7				;ljmp	l05e7           	;goto l05e7 (exit)
;
;
l05d0:
	bcf		p1,4				;clr	p1.4            	;p1.4=0 (not connected)
	nop
	bsf		p1,4				;setb	p1.4            	;p1.4=1
	movf	var_0x1c,w			;mov	a,01ch          	;acc=var_0x1c
	addlw	0x0c				;add	a,#00ch         	;acc += 0x0c
	;mov	dptr,#l05e8     	;pointer=l05e8 (lookup table)
	;movc	a,@a+dptr       	;acc = data from table[acc]
	lcall	table_convert
	movwf	var_0x19			;mov	019h,a          	;var_0x19=acc
	clrf	var_0x1c			;mov	01ch,#000h      	;var_0x1c=0x00
	bsf		bit_24,2			;setb	022h            	;24.2=1
;	lgoto	l05e7				;ljmp	l05e7           	;exit
;
;
l05e7:
	return						;ret	                	;return
;---------------------------------------------------------------
;Set smooth or jump pan/tilt mode related to difference between last and current settings
;This is sent as 10th byte to the motor board.
l06e8:
	movf	var_0x18,w			;mov	a,018h				;acc=var_0x18
	xorlw	0x63				;cjne	a,#063h,l06f3			;if acc!=0x63 goto l06f3
	btfss	status,z			;
	lgoto	l06f3	
	movlw	0x63				;mov	034h,#063h			;var_0x34=0x63
	movwf	var_0x34
	lgoto	l0701				;ljmp	l0701				;goto l0701 (exit)
;
;
l06f3:
	movf	var_0x19,w			;mov	a,019h				;acc=var_0x19
	xorlw	0x63				;cjne	a,#063h,l06fe			;if acc!=0x63 goto l06fe
	btfss	status,z
	goto	l06fe
	movlw	0x63				;mov	034h,#063h			;var_0x34=0x63
	movwf	var_0x34
	lgoto	l0701				;ljmp	l0701				;goto l0701 (exit)
;
;
l06fe:
	movlw	0x5c				;mov	034h,#05ch			;var_0x34 = 0x5c
	movwf	var_0x34
;
l0701:
	return						;ret					;return
;---------------------------------------------------------------
;
l0702:	
	lcall	l_convert_dmx_pan	;acall	l_convert_dmx_pan		;call l_convert_dmx_pan
	lcall	l_convert_dmx_tilt	;acall	l_convert_dmx_tilt		;call l_convert_dmx_tilt
	lcall	l06e8				;acall	l06e8				;call l06e8
	return						;ret					;return
;---------------------------------------------------------------
;
mult8x8:  
	; multiplies m1 * m2 and places result in r_hi and r_lo
	clrf 	r_hi				;clear result registers
	clrf 	r_lo
	movf	m1,w				;load m1
	btfsc	status,z			;=0?
	return						;m1=0, quit
mult_1:
	movf 	r_lo, w				;load result_lo
	addwf 	m2, w				;add m2 to it
	btfsc 	status, c			;check carry bit
	incf 	r_hi, f				;if a carry, increment high byte
	movwf 	r_lo				;save result_lo
	decfsz 	m1, f				;decrement m1
	goto 	mult_1				;loop around
	return						;finished
;
l0709:
	btfsc	bit_22,2			;mov	c,012h				;carry = 22.2 (1=dmx1-256)
	goto	l0712
	btfsc	bit_22,3			;orl	c,013h				;carry != 22.3 (1=dmx257-512)
	goto	l0712				;jc	l0712				;if carry=1 then goto l0712 (dmx mode selected)
	lgoto	l07c6				;ljmp	l07c6				;else goto l07c6
;
;dmx mode is selected
l0712:	
	movf	var_0x10,w			;mov	a,010h				;a=var_0x10 (dmx pan)
	movwf	m1
	movlw	0x0c				;mov	b,#00ch				;b=0x0c
	movwf	m2
	call	mult8x8				;mul	ab
	movf	r_hi,w				;mov	030h,b				;var_0x30 = (hi)(var_0x10 * 0x0c)
	movwf	var_0x30
	movf	r_lo,w				;mov	031h,a				;var_0x31 = (lo)(var_0x10 * 0x0c)
	movwf	var_0x31

	movf	var_0x11,w			;mov	a,011h                  	;a=var_0x11 (dmx_tilt)
	movwf	m1					;
	movlw	0x04				;mov	b,#004h
	movwf	m2
	call	mult8x8				;mul	ab
	movf	r_hi,w				;mov	032h,b				;var_0x32 = (hi)(var_0x11 * 0x04)
	movwf	var_0x32
	movf	r_lo,w				;mov	033h,a				;var_0x33 = (lo)(var_0x11 * 0x04)
	movwf	var_0x33
	btfsc	bit_22,4			;jb	014h,l073b				;if 22.4=1 then goto l073b (use lookup table)
	lgoto	l073b

	movf	var_0x12,w			;mov	a,012h              ;dmx_colour
	movwf	m1
	movlw	0x0c				;mov	b,#00ch
	movwf	m2
	call	mult8x8				;mul	ab					;(lo)a (hi)b = var_0x12 * 0x0c
	;mov	a,#00bh				;acc = 0x0b
	;clr	c					;carry=0
	;subb	a,b					;acc=acc-b
	movf	r_hi,w
	sublw	0x0b
	movwf	var_0x36			;mov	036h,a				;var_0x36=acc
	lgoto	l074b				;ljmp	l074b				;goto l074b
;
;
l073b:
	movf	var_0x12,w			;mov	a,012h				;dmx colour
	movwf	m1
	movlw	0x1c				;mov	b,#01ch
	movwf	m2
	call	mult8x8				;mul	ab					;(lo)a (hi)b = var_0x12 * 0x1c
	movf	r_hi,w				;mov	a,b					;acc = b
	andlw	0x1f				;anl	a,#01fh				;acc &= 0x1f
	;mov	dptr,#l07c7			;pointer = l07c7 (lookup table)
	;movc	a,@a+dptr			;acc = tabledata[acc]
	lcall	table_l07c7
	movwf	var_0x36			;mov	036h,a				;var_0x36=acc
;
l074b:	
	btfsc	bit_22,4			;jb	014h,l075e				;if 22.4=1 then goto l075e (use table)
	goto	l075e

	movf	var_0x13,w			;mov	a,013h				;dmx gobo
	movwf	m1
	movlw	0x0c				;mov	b,#00ch				;b=0x0c
	movwf	m2
	call	mult8x8				;mul	ab					;(lo)a (hi)b = var_0x13 * 0x0c
	;mov	a,#00bh				;a=0x0b
	;clr	c					;carr=0
	;subb	a,b					;acc=acc(0x0b)-b
	movf	r_hi,w
	sublw	0x0b
	movwf	var_0x35			;mov	035h,a				;var_0x35=acc
	lgoto	l076e				;ljmp	l076e				;goto l076e
;
;
l075e:	
	movf	var_0x13,w			;mov	a,013h				;dmx gobo
	movwf	m1
	movlw	0x1c				;mov	b,#01ch
	movwf	m2
	call	mult8x8				;mul	ab				;(lo)a (hi)b = var_0x13 * 0x1c
	movf	r_hi,w				;mov	a,b				;acc=b
	andlw	0x1f				;anl	a,#01fh				;acc &= 0x1f
	;mov	dptr,#l07e7			;pointer = l07e7 (lookpup table)
	;movc	a,@a+dptr			;acc = tabledata[acc]
	lcall	table_l07e7			;
	movwf	var_0x35			;mov	035h,a				;var_0x35=acc
;
l076e:	
	movf	var_0x14,w			;mov	a,014h                  	;dmx shutter
	movwf	m1
	movlw	0x0a				;mov	b,#00ah
	movwf	m2
	call	mult8x8				;mul	ab				;(lo)a (hi)b = var_0x14 * 0x0a
	movf	r_hi,w				;mov	a,b				;acc=b
	xorlw	0x09				;cjne	a,#009h,l077e			;if acc != 0x09 then goto l077e
	btfss	status,z
	goto	l077e
	movlw	0x0a				;mov	a,#001h				;a=0x01
	lgoto	l077f				;ljmp	l077f				;goto l077f
;
;
l077e:	
	movwf	r0					;swap	a				;swap a
	swapf	r0,w
;check if dimmer<nn, if so, close shutter.
l077f:
	movwf	var_0x38			;mov	038h,a				;var_0x38=acc
	movf	var_0x15,w			;mov	a,015h				;acc = var_0x15 (dimmer)
	movwf	m1
	movlw	0x64				;mov	b,#064h				;b=0x64
	movwf	m2
	call	mult8x8				;mul	ab					;(lo)a (hi)b = var_0x15 * 0x64
	movf	r_hi,w				;mov	03ah,b				;var_0x3a = (hi)b
	movwf	var_0x3a
	movf	r_hi,w				;mov	a,b					;acc=b
	bcf		status,c			;clr	c					;carry=0
	addlw	-0x0a			;subb	a,#00ah				;acc=acc-0x0a
	btfss	status,c			;jnc	l0794				;if carry=0 goto l0794
	goto	l0794
	clrf	var_0x38			;mov	038h,#000h			;var_0x38=0
;
l0794:
	movf	var_0x16,w			;mov	a,016h				;dmx_iris
	movwf	m1					
	movlw	0x64				;mov	b,#064h
	movwf	m2
	call	mult8x8				;mul	ab				;(lo)a (hi)b = var_0x16 * 0x64
	movf	r_hi,w				;mov	037h,b				;var_0x37=(hi)b
	movwf	var_0x37
	btfsc	bit_22,7			;jb	017h,l07a5			;if 22.7=1 then goto l07a5
	goto	l07a5
	call	l0702				;acall	l0702				;call l0702
	goto	l07bc				;ljmp	l07bc				;goto l07bc
;
;
l07a5:	
	movf	var_0x17,w			;mov	a,017h
	andlw	0xf8				;anl	a,#0f8h				;var_0x17 &= 0xf8
	btfsc	status,z			;jz	l07ba				;if (var_0x17 & 0xf8)==0 then goto l07ba
	goto	l07ba
	movf	var_0x17,w			;mov	a,017h
	movwf	m1
	movlw	0x28				;mov	b,#028h
	movwf	m2
	call	mult8x8				;mul	ab				;(lo)a (hi)b = var_0x17 * 0x28
	movf	r_hi,w				;mov	a,b				;acc = (hi)b
	addlw	0x3c				;add	a,#03ch				;acc += 0x3c
	movwf	var_0x34			;mov	034h,a				;var_0x34=acc
	lgoto	l07bc				;ljmp	l07bc				;goto l07bc
;
;
l07ba:	
	lcall	l0702				;acall	l0702				;call l0702
;
l07bc:
	bcf		var_0x39,0			;mov	a,#000h				;acc=0
	btfsc	bit_24,0			;mov	c,020h				;carry=24.0
	bsf		var_0x39,0			;mov	acc.0,c				;acc.0=carry
	bcf		bit_24,0			;clr	020h				;24.0=0
	;mov	039h,a				;var_0x39=acc
;
l07c6:
	return						;ret					;return
;---------------------------------------------------------------
;
;l07c7:
;	db 81h, 071h, 061h, 051h, 041h, 031h, 021h, 011h, 010h, 020h, 030h, 040h, 050h, 060h, 070h, 080h
;	db 0bh, 00ah, 009h, 008h, 007h, 006h, 005h, 004h, 003h, 002h, 001h, 000h, 000h, 000h, 000h, 000h
;l07e7:
;	db 80h, 070h, 060h, 050h, 040h, 030h, 020h, 010h, 011h, 021h, 031h, 041h, 051h, 061h, 071h, 081h
;	db 0bh, 00ah, 009h, 008h, 007h, 006h, 005h, 004h, 003h, 002h, 001h, 000h, 000h, 000h, 000h, 000h

;---------------------------------------------------------------
l0807:	
	lcall	l03d5					;lcall	l03d5				;call l03d5
	btfss	bit_21,0				;jnb	008h,l085b			;if 21.0=0 goto l085b (immediate exit) lamp is off
	goto	l085b
	lcall	l0709					;lcall	l0709				;call l0709
	btfss	p1,2					;jnb	p1.2,l081b			;if p1.2=0 (/lamp on) goto l081b
	goto	l081b
	btfsc	bit_20,2				;jb	002h,l081b			;if 20.2=1 goto l081b
	goto	l081b
	btfss	bit_20,1					;jb	001h,l081b			;if 20.1=1 goto l081b
	bcf		p1,2					;clr	p1.2				;/lamp_on = 0
;
l081b:	
	lcall	l_update_motor_board	;lcall	l_update_motor_board				;call l_update_motor_board
	movf	var_0x3a,w				;mov	a,03ah				;a=var_0x3a
	xorlw	0x63					;cjne	a,#063h,l0826			;if a!= 0x63 goto l0826
	btfsc	status,z				;goto l0826 if status=0 (not equal)
	goto	l082a					;ljmp	l082a				;goto l082a
;
;
l0826:	
	btfsc	status,c				;jc	l082a				;if carry=0 goto l082a
	movlw	0x63					;mov	a,#063h				;a=0x63
;
l082a:
	lcall	l_dimmer_dac_lookup		;lcall	l_dimmer_dac_lookup		;call l_dimmer_dac_lookup
	;mov	dptr,#0010h				;	
	;movx	@dptr,a					;external 0x0010 = acc (set dimmer dac)
	movf	var_0x39,w				;mov	a,039h				;acc = var_0x39
	andlw	0x01					;anl	a,#001h				;acc &= 0x01
	btfsc	status,z				;jz	l0846				;if acc=0 goo l0846
	goto	l0846
;
l0837:	
	btfss	p1,2					;jnb	p1.2,l0846			;if /lamp_on=0 goto l0846
	goto	l0846
	;mov	dptr,#0018h
	;movx	a,@dptr				;acc = external 0x0018
	andlw	0x40					;anl	a,#040h				;mask bit 0x40
	btfsc	status,z				;jz	l0846				;if bit=0 then goto l0846
	goto	l0846
	bcf		bit_20,1				;clr	001h				;20.1=0
	bcf		p1,2					;clr	p1.2				;/lamp_on=0
;
l0846:	
	movf	var_0x39,w				;mov	a,039h				;acc = var_0x39
	andlw	0x02					;anl	a,#002h				;mask bit 0x02
	btfsc	status,z				;jz	l0857				;if bit=0 goto l0857
	goto	l0857
	bsf		bit_20,2				;setb	002h				;20.2=1
	btfsc	p1,2					;jb	p1.2,l0859			;if /lamp_on=1 then goto l0859
	goto	l0859
	lcall	l_set_lamp_off			;lcall	l_set_lamp_off			;call l_set_lamp_off
	lgoto	l0859					;ljmp	l0859				;goto l0859
;
;
l0857:
	bcf		bit_20,2				;clr	002h				;20.2=0
;
l0859:
	bcf		bit_21,0				;clr	008h				;21.0=0
;
l085b:	
	;setb	es				;enable serial interrupts
	return							;ret					;return
;---------------------------------------------------------------
;*** read dip switches ***
;var_0x2f = last personality switch setting
;var_0x2e = countdown timer
l_read_dips:
;	mov	dptr,#0000h
;	movx	a,@dptr				;read external 0x0000
;	cpl	a				;invert (bit = 1 shows switch is 'on')
;	mov	b,a				;b=a
;	xrl	a,02fh				;a=a xor var_0x2f
;	jz	l_check_personality_timer	;if a=0 goto l_check_personality_timer - switch was same as last time, move on
;	mov	02eh,#080h			;var_0x2e=0x80 - set number of times for switch to remain constant before decoding
;	mov	a,b				;a=b
;	mov	02fh,a				;var_0x2f=a - update last switch setting
;	ljmp	l_read_channel			;goto l_read_channel - quit for now
;
;
;l_check_personality_timer:
;	mov	a,02eh				;a=var_0x2e
;	xrl	a,#000h				;a=a xor 0x00
;	jz	l_decode_personality		;if a=0 then goto l_decode_personality - if var_0x2e=0 then goto l_decode_personality (decode)
;	dec	02eh				;var_0x2e--    countdown
;	ljmp	l_read_channel			;goto l_read_channel - quit for now
;
;
;switch on = bit=1
;l_decode_personality:
;	mov	a,b				;a=b (external 0x0000)
;	mov	c,acc.0				;carry   =  acc.0
;	mov	010h,c				;bit22.0 =  carry		1=self test
;	mov	c,acc.1				;carry   =  acc.1
;	anl	c,/acc.0			;carry   &= /acc.0
;	mov	011h,c				;bit22.1 =  carry		1=setup
;	mov	c,acc.0				;carry   =  acc.0  c=self test
;	anl	c,acc.1				;carry   &= acc.1  c=c&setup
;	anl	c,acc.2				;carry   &= acc.2  c=c&dmx1-256
;	anl	c,acc.3				;carry   &= acc.3  c=c&dem257-512
;	anl	c,acc.4				;carry   &= acc.4
;	anl	c,acc.5				;carry   &= acc.5
;	anl	c,acc.6				;carry   &= acc.6
;	anl	c,acc.7				;carry   &= acc.7
;	mov	b.0,c				;b.0 = carry
;	mov	c,b.0				;carry = b.0
;	mov	018h,c				;bit 23.0 = carry		1=all switches are on
	bcf		bit_23,0
;	clr	ea				;disable all interrputs

;	mov	c,acc.2				;carry   =  acc.2
;	anl	c,/acc.3			;carry	 &= /acc.3
;	anl	c,/acc.0
;	anl	c,/acc.1
;	mov	012h,c				;bit 22.2 = 1 for dmx1-256 (.2=1, .0 .1 .3=0)
	bsf		bit_22,2
;	mov	c,acc.3				;get dmx257-512 bit
;	anl	c,/acc.2
;	anl	c,/acc.0
;	anl	c,/acc.1
;	mov	013h,c				;bit 22.3 = 1 for dmx257-512 (,3-1, .0 .1 .2=0)
	bcf		bit_22,3
;	mov	c,013h				;carry = bit 22.3
;	orl	c,012h				;carry |= biti 22.2
;	jnc	l_not_dmx			;if carry=0 then goto l_not_dmx - neither bit=1 so not in dmx mode
;	setb	ex0				;enable external interrupt 0
	bsf		intcon,inte		;enable external interrupt (BRK_INT)
;	setb	et1				;enable timer 1 interrupt
	banksel	pie1
	bsf		pie1,tmr1ie		;enable 10mS timer interrupt
	banksel	porta
;	ljmp	l08c7				;goto l08c7
;
;
;l_not_dmx:
;	clr	ex0				;disable external interrupt 0
;	clr	et1				;disable timer 1 interrupt
;
;l08c7:	mov	c,acc.4				;carry = acc.4
;	mov	014h,c				;bit 22.4 = acc.4 (not labelled)
	bcf		bit_22,4
;	clr	017h				;biti 22.7=0
	bcf		bit_22,7
;	mov	c,acc.5				;carry = acc.5
;	mov	015h,c				;bit 22.5 = acc.5 (not labelled)
	bcf		bit_22,5
;	setb	c				;carry=1
;	anl	c,/acc.2
;	anl	c,/acc.3
;	anl	c,/acc.0
;	anl	c,/acc.1
;	mov	01ch,c				;if acc[3..0]==0 then bit 23.4=1
	bcf		bit_23,4
;
;l_read_channel:
;	mov	dptr,#0008h
;	movx	a,@dptr				;read external address 0x0008
;	cpl	a				;invert
;	mov	03bh,a				;var_0x3b=external address 0x008
	movlw	0x01
	movwf	var_0x3b
;	setb	es				;enable serial port interrupts
;	setb	ea				;enable all interrupts
	bsf		intcon,gie
;	ret					;exit
	return
	
;---------------------------------------------------------------
;
l08e8:	
	decfsz	var_0x2a,f		;djnz	02ah,l08f6			;if (var_0x2a--)>0 goto l08f6 (immediate exit)
	goto	l08f6
	decfsz	var_0x2b,f		;djnz	02bh,l08f6			;if (var_0x2b--)>0 goto l08f6 (immediate exit)
	goto	l08f6
	movlw	0x0c			;mov	02bh,#00ch			;var_0x2b=0x0c
	movwf	var_0x2b
	movlw	0xff			;mov	02ah,#0ffh			;var_0x2a=0xff
	movwf	var_0x2a
	bsf		bit_21,2		;setb	00ah				;bit 21.2=1
;
l08f6:
	return					;ret					;return
;---------------------------------------------------------------
;
l08f7:	
	btfss	bit_20,3		;jnb	003h,l0903			;if bit 20.3=0 goto l0903  (immediate exit)
	goto	l0903
	incf	var_0x2c,f		;inc	02ch				;var_0x2c++
	movf	var_0x2c,w		;mov	a,02ch				;acc=var_0x2c
	xorlw	0x66			;cjne	a,#066h,l0903			;if acc!=0x66 goto l0903 (immediate exit)
	btfss	status,z		;skip if equal
	goto	l0903
	bcf		bit_20,3		;clr	003h				;bit 20.3=0
;
l0903:
	return					;ret
;---------------------------------------------------------------
;
l0904:	
	bsf		bit_20,5		;setb	005h				;bit 20.5=1
	return					;ret
;---------------------------------------------------------------
;
l0907:	
	decfsz	var_0x3c,f		;djnz	03ch,l0910			;if(var_0x3c--)>0 goto l0910 (immediate exit)
	goto	l0910
	clrf	var_0x38		;mov	038h,#000h			;var_0x38=0x00
	lcall	l_update_motor_board		;call l_update_motor_board
;
l0910:
	return					;ret
;---------------------------------------------------------------
;
l0911:	
	decfsz	var_0x1f,f		;djnz	01fh,l0910			;if(var_0x1f--)>0 goto l0910 (immediate exit)
	goto	l0910
	bsf		bit_24,0		;setb	020h				;bit 24.0=1
	return					;ret
;---------------------------------------------------------------
;
l0917:	
	btfsc	p1,2			;jb	p1.2,l0920			;if p1.2=1 exit	(/lamp_on)
	goto	l0920
	decfsz	var_0x5a,f		;djnz	05ah,l0920			;if(var_0x5a--)>0 exit
	goto	l0920
	lcall	l_set_lamp_off			;call l_set_lamp_off
;
l0920:	
	return					;ret
;---------------------------------------------------------------
;
l0921:	
	decfsz	var_0x3e,f		;djnz	03eh,l093f			;if (var_0x3e--)>0 exit
	goto	l093f
	decfsz	var_0x3d,f		;djnz	03dh,l093f			;if (var_0x3d--)>0 exit
	goto	l093f
	bsf		p1,0			;setb	p1.0				;p1.0=1 (fan led off)
	bcf		bit_20,1		;clr	001h				;bit 20.1=0
	bsf		p1,1			;setb	p1.1				;lamp led off
	movlw	0x01			;mov	03dh,#001h			;var_0x3d=0x01
	movwf	var_0x3d
	movlw	0x67			;mov	03eh,#067h			;var_0x3e=0x67
	movwf	var_0x3e
	clrf	var_0x48		;mov	048h,#000h			;var_0x48=0x00
	movf	var_0x39,w		;mov	a,039h				;acc=var_0x39
	iorlw	0x02			;orl	a,#002h				;acc|=0x02
	movwf	var_0x39		;mov	039h,a				;var_0x39=acc
	lcall	l_update_motor_board		;call l_update_motor_board
;
l093f:	
	return					;ret
;---------------------------------------------------------------
;
l0940:	
	decf	var_0x1a,f		;dec	01ah				;var_0x1a--
	incf	var_0x1b,f		;inc	01bh				;var_0x1b++
	movf	var_0x1b,w		;mov	a,01bh				;acc=var_0x1b
	xorlw	0x20			;cjne	a,#020h,l0950			;if acc!=0x20, goto l0950
	btfss	status,z	
	goto	l0950
	bcf		p3,5			;clr	p3.5				;p3.5=0 (not connected)
	nop
	bsf		p3,5			;setb	p3.5				;p3.5=1 (not connected)
	bcf		bit_24,1		;clr	021h				;bit 24.1=0
;
l0950:	
	incf	var_0x1c,f		;inc	01ch				;var_0x1c++
	movf	0x1c,w			;mov	a,01ch				;acc=var_0x1c
	xorlw	0x20			;cjne	a,#020h,l09a1			;if acc!=0x20 goto l09a1 (immediate exit)
	btfss	status,z
	goto	l09a1
	bcf		bit_24,2		;clr	022h				;bit 24.2=0
	return					;ret					;return
;---------------------------------------------------------------
;
l095a:	
	btfss	bit_21,1		;jnb	009h,l0970			;if bit 21.1 is 0, goto l0970
	goto	l0970
	bcf		bit_21,1		;clr	009h				;bit 21.1 = 0
	movlw	0x34			;mov	01fh,#034h			;var_0x1f=0x34
	movwf	var_0x1f
	movlw	0x0b			;mov	03ch,#00bh			;var_0x3c=0x0b
	movwf	var_0x3c
	movlw	0x05			;mov	03dh,#005h			;var_0x3d=0x05
	movwf	var_0x3d
	movlw	0xce			;mov	03eh,#0ceh			;var_0x3e=0xce
	movwf	var_0x3e
	clrf	var_0x5a		;mov	05ah,#000h			;var_0x5a=0x00
	call	l08e8			;acall	l08e8				;call l08e8
;
l0970:	
	movf	var_0x1a,w		;mov	a,01ah				;acc = var_0x1a (10ms counter)
	btfss	status,z		;jz	l0976				;if acc=0 goto l0976
	call	l0940			;acall	l0940				;call l0940
;
l0976:	
	btfss	bit_20,4		;jnb	004h,l09a1			;if bit 20.4=0 goto l09a1 (immediate exit)
	goto	l09a1
	bcf		bit_20,4		;clr	004h				;bit 20.4=0
	call	l08f7			;acall	l08f7				;call l08f7
	call	l0904			;acall	l0904				;call l0904
	call	l0907			;acall	l0907				;call l0907
	call	l0911			;acall	l0911				;call l0911
	call	l0917			;acall	l0917				;call l0917
	call	l0921			;acall	l0921				;call l0921
	btfss	bit_20,1		;jnb	001h,l09a1			;if bit 20.1=0, goto l09a1 (immediate exit)
	goto	l09a1
	incf	var_0x59,f		;inc	059h				;var_0x59++
	movf	var_0x59,w		;mov	a,059h				;acc=var_0x59
	xorlw	0x08			;cjne	a,#008h,l0991			;if acc!=0x08 goto l0991
	btfss	status,z
	goto	l0991
;
l0991:		
	btfsc	status,c		;jc	l09a1				;if carry=1 goto l09a1  (immediate exit)
	goto	l09a1
	clrf	var_0x59		;mov	059h,#000h			;var_0x59=0x00
	btfsc	p1,1			;jb	p1.1,l099d			;if p1.1=1 then goto l099d (lamp led)
	goto	l099d
	bsf		p1,1			;setb	p1.1				;lamp led=off
	goto	l09a1			;ajmp	l09a1				;goto l09a1 (immediate exit)
;
;
l099d:		
	bcf		p1,1			;clr	p1.1				;lamp led=on
	;ajmp	l09a1				;goto l09a1 (immediate exit)
;
;
l09a1:	
	return					;ret					;return
;---------------------------------------------------------------
;
l_set_control_mode:
	;jb	018h,l09b3			;if 23.0 = 1 then goto l09b3 - lightwave control
	;jb	010h,l09d2			;if 22.0 = 1 then goto l09d2 - self test
	;jb	011h,l09d7			;if 22.1 = 1 then goto l09d7 - setup
	clrf	var_0x5e		;mov	05eh,#000h			;var_0x5e=0x00
	clrf	var_0x5f		;mov	05fh,#000h			;var_0x5f=0x00
	goto	l0a33			;ajmp	l0a33				;goto l0a33
;
;lightwave control
;l09b3:	mov	a,03bh				;acc = channel setting
;	cjne	a,#001h,l09bd			;if != 0x01 then goto l09bd
;	mov	05eh,#01ah			;var_0x5e=0x1a
;	ajmp	l09dc				;goto l09dc
;
;channel setting=2?
;l09bd:	cjne	a,#002h,l09c5			;
;	mov	05eh,#01bh
;	ajmp	l09dc
;
;channel setting=3?
;l09c5:	cjne	a,#003h,l09cd
;	mov	05eh,#023h
;	ajmp	l09dc
;
;
;l09cd:	mov	05eh,#019h
;	ajmp	l09dc
;
;self test mode
;l09d2:	mov	05eh,#010h
;	ajmp	l09dc
;
;setup mode
;l09d7:	mov	05eh,#011h
;	ajmp	l09dc
;
;------
;l09dc:	mov	a,05eh				;acc = var_0x5e
;	xrl	a,05fh				;same as var_0x5f?
;	jz	l0a25				;yes, goto l0a25
;	mov	a,05eh				;acc = var_0x5e
;	mov	05fh,a				;var_0x5f=acc
;	cjne	a,#010h,l09f1			;if !=self test, goto l09f1
	;mov	05ch,#00ah			;var_0x5c=0x0a
	;mov	05dh,#08dh			;var_0x5d=0x8d
;	mov	dptr,#selftesttable
;	mov	05ch, dph			;load the address of the relevant part of the following table into dptr
;	mov	05dh, dpl
;	ajmp	l0a2d
;
;lightwave control ch4?
;l09f1:	cjne	a,#019h,l09fc			;not lightwave ch4, try next
	;mov	05ch,#013h
	;mov	05dh,#0b7h
;	mov	dptr,#l13b7			;load the address of the relevant part of the following table into dptr
;	mov	05ch,dph
;	mov	05dh,dpl
;	ajmp	l0a2d
;
;lightwave ch1?
;l09fc:	cjne	a,#01ah,l0a07
	;mov	05ch,#013h
	;mov	05dh,#0deh
;	mov	dptr,#l13de			;load the address of the relevant part of the following table into dptr
;	mov	05ch,dph
;	mov	05dh,dpl
;	ajmp	l0a2d
;
;lightwave ch2?
;l0a07:	cjne	a,#01bh,l0a12
	;mov	05ch,#016h
	;mov	05dh,#0f9h
;	mov	dptr,#l16f9			;load the address of the relevant part of the following table into dptr
;	mov	05ch,dph
;	mov	05dh,dpl
;	ajmp	l0a2d
;
;lightwave ch3?
;l0a12:	cjne	a,#023h,l0a1d
	;mov	05ch,#01bh
	;mov	05dh,#0b8h
;	mov	dptr,#l1bb8			;load the address of the relevant part of the following table into dptr
;	mov	05ch,dph
;	mov	05dh,dpl
;	ajmp	l0a2d
;
;must be setup mode then!
;l0a1d:	;mov	05ch,#013h
	;mov	05dh,#090h
;	mov	dptr,#l1390			;load the address of the relevant part of the following table into dptr
;	mov	05ch,dph
;	mov	05dh,dpl
;	ajmp	l0a2d
;
;
;l0a25:	jnb	005h,l0a2f			;if 20.5=0 then goto l0a2f
;	clr	005h				;20.5=0
;	djnz	05bh,l0a2f			;if(var_0x5b--)>0 goto l0a2f
;
;l0a2d:	acall	l0a34				;call l0a34
;
;l0a2f:	setb	009h				;21.1=1
;	setb	008h				;21.0=1
;
l0a33:	
	return					;ret
;---------------------------------------------------------------
;
l0a34:	
	return
;---------------------------------------------------------------
;
selftesttable:
;column:
;1  	duration of 'scene'
;2	pan hi
;3	pan lo
;4	tilt hi
;5	tilt lo
;6	
;7	gobo
;8	colour
;9	iris
;10	shutter
;11	
;12	

;-------------------------------------------------------------
l1dcb:
	;mov	dptr,#0018h		;read external 0x0018
	;movx	a,@dptr
	movwf	r0				;mov	b,a			;store in b
	andlw	0x40			;anl	a,#040h			;mask bit 0x40
	btfsc	status,z		;jnz	l1e0a			;if bit=1 then l1e0a (exit)
	goto	l1e0a
	movf	r0,w			;mov	a,b			;a=b
	andlw	0x10			;anl	a,#010h			;mask bit 0x10 (/lamp_en)
	btfsc	status,z		;jnz	l1e05			;if bit=1 then l1e05
	goto	l1e05
	bcf		p1,2			;clr	p1.2			;/lamp_on=0
	bsf		bit_20,0		;setb	000h			;20.0=1
	movlw	0xa6			;mov	02dh,#0a6h		;var_0x2d=0xa6
	movwf	var_0x2d
	bcf		p1,1			;clr	p1.1			;lamp led on
	bcf		p1,0			;clr	p1.0			;fan led on
	bcf		bit_20,1		;clr	001h			;20.1=0
	movlw	0xff			;mov	a,#0ffh			;acc = 0xff
	movwf	r1
;
l1dea:	
	;push	acc			;push
	movlw	0xff			;mov	a,#0ffh			;acc = 0xff
	movwf	r0
;
l1dee:	
	;push	acc			;push
							;mov	dptr,#0028h		;kick watchdog
	clrwdt					;movx	@dptr,a
	;pop	acc			;restore
	decfsz	r0,f			;dec	a			;acc--
	goto	l1dee			;jnz	l1dee			;if acc!=0 goto l1dee (loop)
	;pop	acc			;restore
	decfsz	r1,f			;dec	a			;acc--
	goto	l1dea			;jnz	l1dea			;if acc!=0 goto l1dea (loop)
	bsf		intcon,inte		;setb	ex1			;external interrupt enabled
	;setb	px1			;external interrupt high priority
	goto	l1e0a			;ljmp	l1e0a			;exit
;
;
l1e05:	
	lcall	l_set_lamp_off		;lamp off
	bsf		bit_20,1			;setb	001h			;20.1=1
;
l1e0a:	
	return						;ret				;return
;
;

;-------------------------------------------------------------
;called from lamp_interrupt routine
l1e0b:
l_set_lamp_off:
	clrwdt						;mov	dptr,#0028h			;external 0x0028 = acc
								;movx	@dptr,a
	bsf		p1,2				;setb	p1.2				;/lamp_on = 1
	;mov	dptr,#0020h			;external 0x0020 = acc - switch lamp off
	;movx	@dptr,a
	;mov	dptr,#0018h			;acc=external 0x0018
	;movx	a,@dptr
	movlw	0x10
	andlw	0x10				;anl	a,#010h				;acc &= 0x10 (mask /lamp_en signal)
	btfsc	status,z			;jz	l_set_lamp_off			;if acc=0 then goto l_set_lamp_off (wait until lamp is extinguished)
	goto	l_set_lamp_off
	bsf		p1,1				;setb	p1.1				;lamp_led = 1 (off)
	bsf		p1,3				;setb	p1.3				;rst_ena=1
	bcf		intcon,inte			;clr	ex1				;disable external interrupt 1
	bcf		bit_20,0			;clr	000h				;bit 20.0=0
	movlw	0x59				;mov	02dh,#059h			;var_0x2d=0x59
	movwf	var_0x2d
	return						;ret					;return
;-------------------------------------------------------------
;
l1e29:	
	;cpl	p1.1				;lamp led at 50% brightness
	goto	l1e29				;ajmp	l1e29				;endless loop!
;
;
l1e2d:	
	movf	var_0x2d,w			;mov	a,02dh
	xorlw	0x59				;xrl	a,#059h
;	btfsc	status,z			;jz	l1e65				;if var_0x2d=0x59 then goto l1e65 (lamp off)
;	cpl	a				;a=!a
;	jz	l1e6d				;if a=0 goto l1e6d
;	mov	b,a				;b=a
;	mov	a,#000h				;a=0
;	mov	c,b.0				;carry = b.0
;	addc	a,#000h				;a=a+0
;	mov	c,b.1				;carry = b.1
;	addc	a,#000h				;a=a+0
;	mov	c,b.2				;carry = b.2
;	addc	a,#000h
;	mov	c,b.3
;	addc	a,#000h
;	mov	c,b.4
;	addc	a,#000h
;	mov	c,b.5
;	addc	a,#000h
;	mov	c,b.6
;	addc	a,#000h
;	mov	c,b.7
;	addc	a,#000h
;	cjne	a,#004h,l1e5f			;if a!=4 goto l1e5f
;	ajmp	l1e29				;goto l1e29 (endless loop)
;
;
;l1e5f:	
;	jb	acc.2,l1e65			;if acc.2=1 goto l1e65
;	ljmp	l1e6d				;goto l1e6d
;
;
;l1e65:	
	movlw	0x59				;mov	02dh,#059h			;var_0x2d=0x59
	movwf	var_0x2d
	bcf		bit_20,0			;clr	000h				;bit 20.0=0
;	ljmp	l1e75				;exit
;
;
;l1e6d:	
;	mov	02dh,#0a6h			;var_0x2d=0xa6
;	setb	000h				;bit 20.0=1
;
;l1e72:	
;	ljmp	l1e75				;exit
;
;
l1e75:	
	return						;ret
;-------------------------------------------------------------
;
l_setup_peripherals:
;	setb	sm0				;scon.7=1
l1e78:	
;	clr	sm1				;scon.6=0

l1e7a:	
;	setb	sm2				;scon.5=1

l1e7c:	
;	setb	ren				;scon.4=1
						;scon = 0x1011xxxx
						;9 bit uart, mode 2,
						;ri will not be activated if the 9th bit of the data is 0.
						;ri will not be activated if a valid stop was not received.

l1e7e:	
;	orl	pcon,#080h			;double baud rate enabled
	bsf		p3,0			;setb	p3.0				;rxd pin = 1
	bsf		p3,2			;setb	p3.2				;brk_int pin = 1
;	setb	it0				;timer0 overflow interrupt enabled
	btfss	bit_21,2		;jnb	00ah,l1e95			;if bit 0a (0x21.2)=0 then goto l1e95
	goto	l1e95
;
l1e8a:	
	bcf		bit_21,2		;clr	00ah				;0x21.2 = 0
;
l1e8c:	
	btfsc	bit_21,1		;jb	00bh,l1e91			;if 0x21.1 = 1 then goto l1e91
	goto	l1e91
	;goto	l1e29			;ajmp	l1e29				;goto l1e29
	nop	;L1E29 is the endless loop, skip for now....
;
;
l1e91:	
	bcf		bit_21,1		;clr	00bh				;0x21.1=0
;	setb	ti				;enable transmit interrupt
;
l1e95:	
;	mov	tmod,#011h			;16 bit timer counter for both tmr0 and tmr1
;
l1e98:	
;	setb	et0				;enable tmr0 overflow interrupt
;	setb	tr0				;start timer 0
;
l1e9c:	
;	mov	a,tl0				;read tmr0
;	nop
;	nop
;	nop
;	xrl	a,tl0				;xor current value with last reading
;	jnz	l1eb0				;if the value has changed, goto l1eb0
;	mov	a,tl0				;one more chance
;	nop
;	nop
;	nop
;	xrl	a,tl0
;	jnz	l1eb0				;if the value has changed, goto l1eb0
;	ajmp	l1e29				;otherwise, goto l1e29
;
;
l1eb0:	
	btfss	bit_20,0		;jnb	000h,l1ec5			;if 0x20.0=0 then goto l1ec5
	goto	l1ec5
	btfsc	bit_20,1		;jb	001h,l1ec5			;if 0x20.1=1 then goto l1ec5
	goto	l1ec5
	btfsc	bit_20,3		;jb	003h,l1ec5			;if 0x20.3=1 then goto l1ec5
	goto	l1ec5
	;setb	ex1				;enable tmr1 overflow interrupt
	;setb	px1				;set tmr1 interrupt to be high priority
	bcf		p1,2			;clr	p1.2				;/lamp_on pin =0
	bcf		p1,3			;clr	p1.3				;rst_ena pin =0
	bcf		p1,1			;clr	p1.1				;lamp led = on
	bcf		p1,0			;clr	p1.0				;fan led = on
;
l1ec5:	
	call	l1e2d			;acall	l1e2d				;call l1e2d
	btfss	bit_20,0		;jnb	000h,l1ed4			;if 0x20.0=0 then goto l1ed4
	goto	l1ed4
	btfsc	bit_20,1		;jb	001h,l1ed4			;if 0x20.1=1 then goto l1ed4
	goto	l1ed4
	bcf		p1,2			;clr	p1.2				;/lamp_on=0
	bsf		bit_20,0		;setb	000h				;0x20.0=1
	movlw	0xa6			;mov	02dh,#0a6h			;var_0x2d = 0xa6
	movwf	var_0x2d
;
l1ed4:	
	bsf		intcon,gie		;setb	ea				;enable global interrupts
	return					;ret					;return
;-------------------------------------------------------------
;*** main loop ***
l_main_loop:
	clrwdt					;mov	dptr,#0028h
							;movx	@dptr,a				;external 0x0028 = acc
							;movx	@dptr,a				;(kick watchdog)
	bsf		bit_21,0	;lamp on...
	lcall	l0807		;DMX calculations
	lcall	l_update_motor_board
	
	movlw	0x0a
	addwf	var_0x10,f
	addwf	var_0x11,f
	addwf	var_0x12,f
	addwf	var_0x13,f
	addwf	var_0x14,f
	addwf	var_0x15,f
	addwf	var_0x16,f
	addwf	var_0x17,f
	
	lcall	l095a				;call l095a
	lcall	l_read_dips			;call l_read_dips
	lcall	l_set_control_mode		;call l_set_control_mode
	lcall	l0807				;call l0807
	lcall	l_setup_peripherals		;call l_setup_peripherals
	lgoto	l_main_loop		;ljmp	l_main_loop			;goto l_main_loop
;
;-------------------------------------------------------------
	
	end
